/*
 * SHA-1 in C
 * By Steve Reid <steve@edmweb.com>
 * 100% Public Domain
 *
 * filename : sha1.h
 *
 * last edit : 05.09.2000
 *    by Oliver Stecklina
 */

#ifndef _SHA1_H
#define _SHA1_H

#include <linux/types.h>

#ifndef LIB_DEBUG
	#include <linux/string.h>
#else
	#include <string.h>
#endif

typedef struct {
    u_int32_t state[5];
    u_int32_t count[2];
    unsigned char buffer[64];
} SHA1_CTX;

void SHA1Transform(u_int32_t state[5], const unsigned char buffer[64]);
void SHA1Init(SHA1_CTX* context);
void SHA1Update(SHA1_CTX* context, const unsigned char* data, u_int32_t len);
void SHA1Final(unsigned char digest[20], SHA1_CTX* context);

#endif
