static const uint32_t iso88597_to_ucs4[96] = {
  [0xA0 - 0xA0] = 0x00A0,
  [0xA1 - 0xA0] = 0x2018,
  [0xA2 - 0xA0] = 0x2019,
  [0xA3 - 0xA0] = 0x00A3,
  [0xA6 - 0xA0] = 0x00A6,
  [0xA7 - 0xA0] = 0x00A7,
  [0xA8 - 0xA0] = 0x00A8,
  [0xA9 - 0xA0] = 0x00A9,
  [0xAB - 0xA0] = 0x00AB,
  [0xAC - 0xA0] = 0x00AC,
  [0xAD - 0xA0] = 0x00AD,
  [0xAF - 0xA0] = 0x2015,
  [0xB0 - 0xA0] = 0x00B0,
  [0xB1 - 0xA0] = 0x00B1,
  [0xB2 - 0xA0] = 0x00B2,
  [0xB3 - 0xA0] = 0x00B3,
  [0xB4 - 0xA0] = 0x0384,
  [0xB5 - 0xA0] = 0x0385,
  [0xB6 - 0xA0] = 0x0386,
  [0xB7 - 0xA0] = 0x00B7,
  [0xB8 - 0xA0] = 0x0388,
  [0xB9 - 0xA0] = 0x0389,
  [0xBA - 0xA0] = 0x038A,
  [0xBB - 0xA0] = 0x00BB,
  [0xBC - 0xA0] = 0x038C,
  [0xBD - 0xA0] = 0x00BD,
  [0xBE - 0xA0] = 0x038E,
  [0xBF - 0xA0] = 0x038F,
  [0xC0 - 0xA0] = 0x0390,
  [0xC1 - 0xA0] = 0x0391,
  [0xC2 - 0xA0] = 0x0392,
  [0xC3 - 0xA0] = 0x0393,
  [0xC4 - 0xA0] = 0x0394,
  [0xC5 - 0xA0] = 0x0395,
  [0xC6 - 0xA0] = 0x0396,
  [0xC7 - 0xA0] = 0x0397,
  [0xC8 - 0xA0] = 0x0398,
  [0xC9 - 0xA0] = 0x0399,
  [0xCA - 0xA0] = 0x039A,
  [0xCB - 0xA0] = 0x039B,
  [0xCC - 0xA0] = 0x039C,
  [0xCD - 0xA0] = 0x039D,
  [0xCE - 0xA0] = 0x039E,
  [0xCF - 0xA0] = 0x039F,
  [0xD0 - 0xA0] = 0x03A0,
  [0xD1 - 0xA0] = 0x03A1,
  [0xD3 - 0xA0] = 0x03A3,
  [0xD4 - 0xA0] = 0x03A4,
  [0xD5 - 0xA0] = 0x03A5,
  [0xD6 - 0xA0] = 0x03A6,
  [0xD7 - 0xA0] = 0x03A7,
  [0xD8 - 0xA0] = 0x03A8,
  [0xD9 - 0xA0] = 0x03A9,
  [0xDA - 0xA0] = 0x03AA,
  [0xDB - 0xA0] = 0x03AB,
  [0xDC - 0xA0] = 0x03AC,
  [0xDD - 0xA0] = 0x03AD,
  [0xDE - 0xA0] = 0x03AE,
  [0xDF - 0xA0] = 0x03AF,
  [0xE0 - 0xA0] = 0x03B0,
  [0xE1 - 0xA0] = 0x03B1,
  [0xE2 - 0xA0] = 0x03B2,
  [0xE3 - 0xA0] = 0x03B3,
  [0xE4 - 0xA0] = 0x03B4,
  [0xE5 - 0xA0] = 0x03B5,
  [0xE6 - 0xA0] = 0x03B6,
  [0xE7 - 0xA0] = 0x03B7,
  [0xE8 - 0xA0] = 0x03B8,
  [0xE9 - 0xA0] = 0x03B9,
  [0xEA - 0xA0] = 0x03BA,
  [0xEB - 0xA0] = 0x03BB,
  [0xEC - 0xA0] = 0x03BC,
  [0xED - 0xA0] = 0x03BD,
  [0xEE - 0xA0] = 0x03BE,
  [0xEF - 0xA0] = 0x03BF,
  [0xF0 - 0xA0] = 0x03C0,
  [0xF1 - 0xA0] = 0x03C1,
  [0xF2 - 0xA0] = 0x03C2,
  [0xF3 - 0xA0] = 0x03C3,
  [0xF4 - 0xA0] = 0x03C4,
  [0xF5 - 0xA0] = 0x03C5,
  [0xF6 - 0xA0] = 0x03C6,
  [0xF7 - 0xA0] = 0x03C7,
  [0xF8 - 0xA0] = 0x03C8,
  [0xF9 - 0xA0] = 0x03C9,
  [0xFA - 0xA0] = 0x03CA,
  [0xFB - 0xA0] = 0x03CB,
  [0xFC - 0xA0] = 0x03CC,
  [0xFD - 0xA0] = 0x03CD,
  [0xFE - 0xA0] = 0x03CE,
};
static const struct gap from_idx[] = {
  { start: 0x00a0, end: 0x00bd, idx:     0 },
  { start: 0x0384, end: 0x03ce, idx:  -710 },
  { start: 0x2015, end: 0x2019, idx: -7948 },
  { start: 0xffff, end: 0xffff, idx:     0 }
};
static const char iso88597_from_ucs4[] = {

  '\xa0', '\x00', '\x00', '\xa3', '\x00', '\x00', '\xa6', '\xa7',
  '\xa8', '\xa9', '\x00', '\xab', '\xac', '\xad', '\x00', '\x00',
  '\xb0', '\xb1', '\xb2', '\xb3', '\x00', '\x00', '\x00', '\xb7',
  '\x00', '\x00', '\x00', '\xbb', '\x00', '\xbd', '\xb4', '\xb5',
  '\xb6', '\x00', '\xb8', '\xb9', '\xba', '\x00', '\xbc', '\x00',
  '\xbe', '\xbf', '\xc0', '\xc1', '\xc2', '\xc3', '\xc4', '\xc5',
  '\xc6', '\xc7', '\xc8', '\xc9', '\xca', '\xcb', '\xcc', '\xcd',
  '\xce', '\xcf', '\xd0', '\xd1', '\x00', '\xd3', '\xd4', '\xd5',
  '\xd6', '\xd7', '\xd8', '\xd9', '\xda', '\xdb', '\xdc', '\xdd',
  '\xde', '\xdf', '\xe0', '\xe1', '\xe2', '\xe3', '\xe4', '\xe5',
  '\xe6', '\xe7', '\xe8', '\xe9', '\xea', '\xeb', '\xec', '\xed',
  '\xee', '\xef', '\xf0', '\xf1', '\xf2', '\xf3', '\xf4', '\xf5',
  '\xf6', '\xf7', '\xf8', '\xf9', '\xfa', '\xfb', '\xfc', '\xfd',
  '\xfe', '\xaf', '\x00', '\x00', '\xa1', '\xa2',
};
