$(libc)-dev: $(stamp_install) debian/control $(mkdir)/sysdeps.mk
	$(checkroot)
	$(debian-clean)
	-rm -rf $(tmpdir)/$@

	$(make_directory) $(tmpdir)/$@/DEBIAN
	$(make_directory) $(tmpdir)/$@$(bindir)
	$(INSTALL_PROGRAM) $(addprefix $(install_root)$(bindir)/, \
	gencat getconf mtrace) $(tmpdir)/$@$(bindir)/.
ifeq ($(DEB_BUILD_OPTION_STRIP),yes)
	-$(STRIP) --strip-unneeded -R .comment -R .note $(tmpdir)/$@$(bindir)/*
endif
	$(make_directory) $(tmpdir)/$@$(libdir)
	$(INSTALL_DATA) $(install_root)$(libdir)/*.o $(tmpdir)/$@$(libdir)/.
	$(INSTALL_DATA) $(install_root)$(libdir)/*.a $(tmpdir)/$@$(libdir)/.
	rm -f $(tmpdir)/$@$(libdir)/*_?.a
ifeq ($(DEB_BUILD_OPTION_STRIP),yes)
# Don't strip linker scripts.
	@tostrip=; for file in $(tmpdir)/$@$(libdir)/*; do \
	  case `file $$file` in \
	  *text) ;; *) tostrip="$$tostrip $$file" ;; esac; \
	done; echo "$(STRIP) -g $$tostrip"; \
	$(STRIP) -g $$tostrip
endif
# Install development links.
	for f in $(install_root)$(libdir)/lib*.so; do \
	  case "$$f" in \
	  *-$(VERSION).so | *-0.[789].so) ;; \
	  */libSegFault.so|*/libthread_db.so) ;; \
	  */libnss1_*.so) ;; \
	  *) cp -df $$f $(tmpdir)/$@$(libdir)/. || exit 1 ;; \
	  esac; \
	done
ifneq ($(libdir),/lib)
# Make links absolute, not relative
	cd $(tmpdir)/$@$(libdir); \
	for link in `find . -name '*.so' -type l`; do \
	  case "$$link" in *libnss1*) ;; \
	    *) linksrc=$$(readlink $$link | sed 's%../..%%') ;; \
	  esac; rm -f $$link; ln -sf $$linksrc $$link; done
endif
	$(make_directory) $(tmpdir)/$@$(includedir)
	cp -a $(install_root)$(includedir) $(tmpdir)/$@/usr/
ifeq ($(DEB_HOST_GNU_SYSTEM),linux)
	cp -R $(addprefix $(LINUX_SOURCE)/include/,asm linux) \
	$(tmpdir)/$@$(includedir)/.
	rm -rf $(tmpdir)/$@$(includedir)/linux/modules
	rm -f $(tmpdir)/$@$(includedir)/linux/modversions.h
ifeq ($(DEB_HOST_GNU_CPU),sparc)
	cp -R $(LINUX_SOURCE)/include/asm-sparc \
	$(tmpdir)/$@$(includedir)/.
endif
endif
	$(make_directory) $(tmpdir)/$@$(docdir)/$@
	$(INSTALL_DATA) debian/changelog $(tmpdir)/$@$(docdir)/$@/changelog.Debian
	-find $(tmpdir)/$@$(docdir)/$@ -type f | xargs -r gzip -9f
	$(INSTALL_DATA) debian/copyright $(tmpdir)/$@$(docdir)/$@/.

	cp -a debian/$@/* $(tmpdir)/$@/DEBIAN

	dpkg-gencontrol -isp -p$@ -P$(tmpdir)/$@ $(libc_dev_control_flags)
	chown -R root.root $(tmpdir)/$@
	chmod -R go=rX $(tmpdir)/$@
	dpkg --build $(tmpdir)/$@ ..

