ifeq ($(cross_compiling),no)
LOCALEDEF=I18NPATH=. $(objdir)/elf/ld.so --library-path $(objdir):$(objdir)/elf $(objdir)/locale/localedef
else
LOCALEDEF=I18NPATH=. localedef
endif

locales: $(stamp_install) debian/control $(mkdir)/sysdeps.mk
	$(checkroot)
	$(debian-clean)
	-rm -rf $(tmpdir)/$@

	$(make_directory) $(tmpdir)/$@/DEBIAN
ifeq ($(cross_compiling),yes)
	$(warning Building locales package with build system 'localedef', \
	if this is not from the same source version of glibc as what is \
	currently being built, this package may be broken.)
endif
	$(MAKE) -C $(srcdir)/localedata install_root=$(install_root) \
	objdir=$(objdir) LOCALEDEF="$(LOCALEDEF)" install-locales
	cd $(srcdir)/localedata && while read locale charset; do \
	   case $$locale in \#*) continue;; esac; \
	   $(LOCALEDEF) -i locales/`echo $$locale | sed 's/\([^.]*\).*/\1/'` \
			-c -f charmaps/$$charset \
			-u repertoiremaps/mnemonic.ds \
			$(install_root)$(datadir)/locale/$$locale; \
	done < $(top_srcdir)/debian/extra-locales
	$(make_directory) $(tmpdir)/$@$(datadir)/.
	cp -a $(install_root)$(datadir)/locale $(tmpdir)/$@$(datadir)/.
	$(make_directory) $(tmpdir)/$@/etc
	mv -f $(tmpdir)/$@$(datadir)/locale/locale.alias $(tmpdir)/$@/etc/.
	ln -sf /etc/locale.alias $(tmpdir)/$@$(datadir)/locale/locale.alias

	$(make_directory) $(tmpdir)/$@$(docdir)/$@
	$(INSTALL_DATA) $(srcdir)/localedata/ChangeLog $(tmpdir)/$@$(docdir)/$@/changelog
	$(INSTALL_DATA) debian/changelog $(tmpdir)/$@$(docdir)/$@/changelog.Debian
	$(INSTALL_DATA) $(srcdir)/localedata/README $(tmpdir)/$@$(docdir)/$@/.
	-gzip -9f $(tmpdir)/$@$(docdir)/$@/*
	$(INSTALL_DATA) debian/copyright $(tmpdir)/$@$(docdir)/$@/.

	cp -a debian/locales/* $(tmpdir)/$@/DEBIAN
	dpkg-gencontrol -isp -p$@ -P$(tmpdir)/$@ $($@_control_flags)
	chown -R root.root $(tmpdir)/$@
	chmod -R go=rX $(tmpdir)/$@
	dpkg --build $(tmpdir)/$@ ..
