control_deps := $(addprefix debian/control.in/, \
libc6 libc6.1 libc0.2 libnss1-compat libc6-64)

threads_archs := alpha arm i386 m68k mips mipsel powerpc sparc

debian/control.in/libc6: debian/control.in/libc debian/rules.d/control.mk
	sed -e 's%@libc@%libc6%g' \
	    -e 's%@archs@%arm i386 m68k mips mipsel powerpc sparc%g' < $< > $@

debian/control.in/libc6.1: debian/control.in/libc debian/rules.d/control.mk
	sed -e 's%@libc@%libc6.1%g;s%@archs@%alpha%g' < $< > $@

debian/control.in/libc0.2: debian/control.in/libc debian/rules.d/control.mk
	sed -e 's%@libc@%libc0.2%g;s%@archs@%hurd-i386%g;s/nscd, //' < $< > $@

debian/control: debian/control.in/main $(DEB_HOST_GNU_TYPE) $(control_deps) \
		   debian/sysdeps/soname.mk debian/sysdeps/config.mk \
		   debian/rules.d/control.mk
	cat debian/control.in/main		>  $@T
	cat debian/control.in/libc6		>> $@T
	cat debian/control.in/libc6.1		>> $@T
	cat debian/control.in/libc0.2		>> $@T
ifeq ($(WANT_LIB_64),yes)
	cat debian/control.in/libc6-64		>> $@T
endif
ifeq ($(WANT_NSS1_COMPAT),yes)
	cat debian/control.in/libnss1-compat	>> $@T
endif
	sed -e 's%@libc@%$(libc)%g;s%@glibc@%$(glibc)%g' \
	    -e 's%@threads_archs@%$(threads_archs)%g' < $@T > $@
	rm $@T
