ifeq ($(DEB_HOST_GNU_SYSTEM),gnu)
  libc_dev_control_flags = -DDepends="gnumach-dev, hurd-dev" -DReplaces="glibc2-dev" -DConflicts="glibc2-dev"
  libc_control_flags = -DReplaces="glibc2" -DConflicts="glibc2"
  locales_control_flags = -DReplaces="glibc2"
  timezones_control_flags = -DReplaces="glibc2"
endif

ifeq ($(DEB_HOST_GNU_SYSTEM),linux)
#  libc_control_flags = -DDepends="timezone-config"
  libc_control_flags += -DRecommends="locales"
  libc_control_flags += -DSuggests="$(glibc)-doc"
  libc_control_flags += -DProvides="gconv-modules"
  libc_dev_control_flags  = -DRecommends="c-compiler"
  libc_dev_control_flags += -DSuggests="$(glibc)-doc"
  libc_dev_control_flags += -DConflicts="libc-dev"
  libc_dev_control_flags += -DReplaces="ldso (<< 1.9.0-0), \
    man-db (<= 2.3.10-41), gettext (<= 0.10.26-1), ppp (<= 2.2.0f-24), libgdbmg1-dev (<= 1.7.3-24)"
endif

ifeq ($(DEB_HOST_GNU_TYPE),alpha-linux)
  libc_control_flags += -DDepends="ldso (>= 1.9.9-3)" \
    -DConflicts="timezone, timezones, libwcsmbs, libc6-doc, libtricks, apt (<< 0.3.0), \
                 libglib1.2 (<< 1.2.1-2), $(libc)-bin, gconv-modules" \
    -DReplaces="timezone, timezones, $(libc)-dev (<< 2.0.110-1), $(libc)-bin, \
                locales (<< 2.1.3-5), gconv-modules"
  libc_dev_control_flags += -DConflicts="libc-dev, libstdc++2.9-dev, libdl1-dev, \
  libdb1-dev, libgdbm1-dev, libpthread0-dev, gcc (<= 2.7.2.3-1), \
  libncurses4-dev (<< 4.2-3.1), libreadlineg2-dev (<< 2.1-13.1)"
endif
ifeq ($(DEB_HOST_GNU_TYPE),arm-linux)
  libc_control_flags += -DDepends="ldso (>= 1.9.9-3)" \
    -DConflicts="timezones, gconv-modules" \
    -DReplaces="timezones, $(libc)-dev (<< 2.0.110-1), locales (<< 2.1.3-5), gconv-modules"
endif
ifeq ($(DEB_HOST_GNU_TYPE),i386-linux)
  libc_control_flags += -DPre-Depends="ldso (>= 1.9.11-2.1)" \
    -DConflicts="libc5 (<< 5.4.33-7), libpthread0 (<< 0.7-10), timezone, timezones, \
    libwcsmbs, libc6-doc, libtricks, apt (<< 0.3.0), libglib1.2 (<< 1.2.1-2), $(libc)-bin, gconv-modules" \
    -DReplaces="timezone, timezones, $(libc)-dev (<< 2.0.110-1), $(libc)-bin, \
    locales (<< 2.1.3-5), gconv-modules"
  libc_dev_control_flags += -DConflicts="libc-dev, libstdc++2.9-dev, libdl1-dev, \
  libdb1-dev, libgdbm1-dev, libpthread0-dev, gcc (<= 2.7.2.3-1)"
endif
ifeq ($(DEB_HOST_GNU_TYPE),m68k-linux)
  libc_control_flags += -DPre-Depends="ldso (>= 1.9.11-2.1)" \
    -DConflicts="libc5 (<< 5.4.33-7), libpthread0 (<< 0.7-10), timezone, timezones, \
    libwcsmbs, libc6-doc, libtricks, apt (<< 0.3.0), libglib1.2 (<< 1.2.1-2), $(libc)-bin, gconv-modules" \
    -DReplaces="timezone, timezones, $(libc)-dev (<< 2.0.110-1), $(libc)-bin, \
    locales (<< 2.1.3-5), gconv-modules"
  libc_dev_control_flags += -DConflicts="libc-dev, libstdc++2.10-dev, libdl1-dev, libdb1-dev, \
  libgdbm1-dev, libpthread0-dev, gcc (<= 2.7.2.3-1)"
endif
ifeq ($(DEB_HOST_GNU_TYPE),mips-linux)
  libc_control_flags += -DDepends="ldso (>= 1.9.9-3)" \
    -DConflicts="timezones" -DReplaces="timezones"
endif
ifeq ($(DEB_HOST_GNU_TYPE),mipsel-linux)
  libc_control_flags += -DDepends="ldso (>= 1.9.9-3)" \
    -DConflicts="timezones" -DReplaces="timezones"
endif
ifeq ($(DEB_HOST_GNU_TYPE),powerpc-linux)
  libc_control_flags += -DDepends="ldso (>= 1.9.9-3)" \
    -DConflicts="libstdc++2.9 (<< 2.91.58-2.1), libstdc++2.8 (<< 2.90.29-1), libc6-doc, \
    timezones, $(libc)-bin, gconv-modules" \
    -DReplaces="timezones, $(libc)-dev (<< 2.0.110-1), $(libc)-bin, \
    locales (<< 2.1.3-5), gconv-modules"
endif
ifeq ($(DEB_HOST_GNU_TYPE),s390-linux)
  libc_control_flags += -DDepends="ldso (>= 1.9.9-3)"
endif
ifeq ($(DEB_HOST_GNU_TYPE),sparc-linux)
  libc_control_flags += -DDepends="ldso (>= 1.9.11-5)" \
    -DConflicts="libc5 (<< 5.3.12-2), libpthread0 (<< 0.7-10), libwcsmbs, libc6-doc, timezones, $(libc)-bin, gconv-modules" \
    -DReplaces="timezones, $(libc)-dev (<< 2.0.110-1), $(libc)-bin, locales (<< 2.1.3-5), gconv-modules"
  libc_dev_control_flags += -DConflicts="libc-dev, libdl1-dev, libdb1-dev, libgdbm1-dev, libpthread0-dev, gcc (<= 2.7.2.3-1)"
endif

ifneq ($(libc),libc6)
  libc_dev_control_flags += -DProvides="libc-dev, libc6-dev"
else
  libc_dev_control_flags += -DProvides="libc-dev"
endif



