#!/bin/bash

. ../functions

THIS_PKG="iptables-1.2.4"
BUILD_ROOT="$(pwd)/_"
BLOG="$(pwd)/blog.$THIS_PKG"

blog_header

rm -rf $THIS_PKG
md5_source $THIS_PKG.tar.bz2
tar xIf $THIS_PKG.tar.bz2

( cd $THIS_PKG

md5_source ../Makefile.patch
echo "->Applying Makefile patch" >>$BLOG 2>&1
patch -N -p1 <../Makefile.patch >>$BLOG 2>&1
md5_source ../iptables-binsert.c
echo "->Copying iptables-binsert" >>$BLOG 2>&1
cp -va ../iptables-binsert.c . >>$BLOG 2>&1

KDIR=$(cd ../../kernel/default/linux ; pwd -P)

rm -rf $BUILD_ROOT
mkdir -p $BUILD_ROOT

make KERNEL_DIR=$KDIR DESTDIR=$BUILD_ROOT clean install install-experimental >>$BLOG 2>&1

)

md5_summary
blog_footer
