/*
 * name: dev_behaviour.h
 *
 * last edit: 19 Januar 2002
 */

#ifndef _DEV_BEHAVIOUR_H
#define _DEV_BEHAVIOUR_H

#include <linux/config.h>
#include <linux/skbuff.h>
#include <linux/netdevice.h>

#ifdef CONFIG_IPSEC_NF
#define DEV_CRYPT		0x00000001
#endif

#ifdef CONFIG_CLOSEIPSEC
#define DEV_OPEN		0x00000002
#endif

struct dev_behaviour_t {
	struct net_device *dev;
	int ifindex;

	unsigned long behaviour;
	struct dev_behaviour_t *next;

#ifdef CONFIG_IPSEC_NF
	char name[IFNAMSIZ];
	void *sysctl;
#endif

#ifdef CONFIG_CLOSEIPSEC
	atomic_t set;

	unsigned long in_dropped;
	unsigned long out_dropped;
	int (*hard_start_xmit) (struct sk_buff *skb, struct net_device *dev);
#endif
};

extern struct dev_behaviour_t *get_default_behav(void);
extern struct dev_behaviour_t *get_first_behav(void);
extern struct dev_behaviour_t *get_behav(struct net_device *dev);
extern int update_behav(struct dev_behaviour_t *p, int pref, int value);

extern int register_dev_behav(struct net_device *dev);
extern int unregister_dev_behav(struct net_device *dev);

extern struct dev_behaviour_t *init_dev_behaviour(void);
extern int cleanup_dev_behaviour(void);

#endif
